transform_units_precipitation <- function(data, original_units, new_units,
                                          var_name) {
  if (original_units == "ms-1") {
    if (new_units == "mm") {
      data[[1]]$data <- data[[1]]$data * 3600 * 24 * 1000
      data[[1]]$attrs$Variable$metadata[[var_name]]$units <- 'mm'
    } else if (new_units == "m") {
     data[[1]]$data <- data[[1]]$data * 3600 * 24
     data[[1]]$attrs$Variable$metadata[[var_name]]$units <- 'm'
    } else if (new_units == "kgm-2s-1") {
     data[[1]]$data <- data[[1]]$data * 1000 
     data[[1]]$attrs$Variable$metadata[[var_name]]$units <- 'kg m-2 s-1'
    } else {
      stop(paste("Unknown transformation from", original_units, "to",
                 new_units))
    }
  } else if (original_units == "mm") {
    if (new_units == "ms-1") {
      data[[1]]$data <- data[[1]]$data / (3600 * 24 * 1000)
      data[[1]]$attrs$Variable$metadata[[var_name]]$units <- 'm s-1'
    } else if (new_units == "m") {
      data[[1]]$data <- data[[1]]$data / 1000
      data[[1]]$attrs$Variable$metadata[[var_name]]$units <- 'mm'
    } else if (new_units == "kgm-2s-1") {
#      data[[1]]$data <- data[[1]]$data / (3600 * 24 * 1000)
      data[[1]]$attrs$Variable$metadata[[var_name]]$units <- 'kg m-2 s-1'
    } else {
      stop(paste("Unknown transformation from", original_units, "to",
                 new_units))
    }
  } else if (original_units == "m") {
    if (new_units == "ms-1") {
    } else if (new_units == "mm") {
    } else if (new_units == "kgm-2s-1") {
    } else {
      stop(paste("Unknown transformation from", original_units, "to",
                 new_units))
    }
  } else if (original_units == "kgm-2s-1") {
    if (new_units == "ms-1") {
    } else if (new_units == "mm") {
    } else if (new_units == "kgm-2s-1") {
    } else {
      stop(paste("Unknown transformation from", original_units, "to",
                 new_units))
    }
  } else {
    stop("Unknown precipitation units transformation")
  }

  return(data)
}


